/********************************** (C) COPYRIGHT *******************************
ʹ25Mⲿ
ĬΪ8MҪ޸һλã
1/CH32V307VCT6/Peripheral/inc/ch32v30x.h       #define HSE_VALUE    ((uint32_t)25000000)
2/CH32V307VCT6/User/system_ch32v30x.c          #define SYSCLK_FREQ_HSE    HSE_VALUE
256K FLASH 64K SRAM  V4F ں
ϵͳ洢С˸ʽݣֽڴڵ͵ַֽڴڸߵַ
*******************************************************************************/

#include "debug.h"

void RCC_Configuration(void); //ʱ
void GPIO_Configuration(void);//IO
void USART_Configuration(void);
void DMA_Configuration(void);
void NVIC_Config(void);

/* Global Variable */
unsigned char G_prn_flag = 0;
unsigned char usart1_rx[usart_max],usart1_rxbuf[usart_max],G_usart1_Rsign = 0;

/*********************************************************************
 * @fn      main
 *
 * @brief   Main program.
 *
 * @return  none
 */
int main(void)
{
	//NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2);
	NVIC_Config();
	Delay_Init();
	RCC_Configuration();
	GPIO_Configuration();
	USART_Configuration();//USART_Printf_Init(9600);
	printf("SystemClk:%d\r\n",SystemCoreClock);
	DMA_Configuration();
	printf("This is printf example\r\n");

	while(1)
    {
	    if(G_usart1_Rsign == 1)
       {
           printf("test OK!\n");
           USART_COM_DataReceiver(usart1_rxbuf);
           G_usart1_Rsign = 0;
       }
	}
}


void DMA_Configuration(void)
{
  DMA_InitTypeDef DMA_InitStructure;
  /* DMA ͨ5  --USART1*/
  DMA_DeInit(DMA1_Channel5);//5ͨΪʼֵ
  DMA_InitStructure.DMA_PeripheralBaseAddr = (unsigned int)(&USART1->DATAR); ;//òԶDMAַ,USART1DRĴ
  DMA_InitStructure.DMA_MemoryBaseAddr = (unsigned int)usart1_rx; //òԶDMAڴַ
  DMA_InitStructure.DMA_DIR = DMA_DIR_PeripheralSRC;//òָΪݴĿĵػԴ,...DSTȻĿĵ
  DMA_InitStructure.DMA_BufferSize = usart_max;//ﶨDMAĴСλݱĵλҲ
  DMA_InitStructure.DMA_PeripheralInc = DMA_PeripheralInc_Disable;//趨ַĴǷ
  DMA_InitStructure.DMA_MemoryInc = DMA_MemoryInc_Enable;//趨ڴַĴ
  DMA_InitStructure.DMA_PeripheralDataSize = DMA_PeripheralDataSize_Byte;//˵ݿ(Byte˵8λ)
  DMA_InitStructure.DMA_MemoryDataSize = DMA_MemoryDataSize_Byte;//˵ݿ
  DMA_InitStructure.DMA_Mode = DMA_Mode_Normal;////Normal;DMAĹģʽ,ѭͷѭѡ
  DMA_InitStructure.DMA_Priority = DMA_Priority_Medium;//趨ͨжȼ,ȶΪеȵȼ???
  DMA_InitStructure.DMA_M2M = DMA_M2M_Disable;//DMAͨڴ浽ڴ洫书ܣȻҪֹ(ڴֱӵĿòƿ)
  DMA_Init(DMA1_Channel5, &DMA_InitStructure);//趨ĲʼDMAͨ5Ĵ
  DMA_Cmd(DMA1_Channel5, ENABLE);
  DMA_ITConfig(DMA1_Channel5, DMA_IT_TC, DISABLE);
 }

void GPIO_Configuration(void)
{
    GPIO_InitTypeDef GPIO_InitStructure;

    //RCC_APB2PeriphClockCmd(RCC_APB2Periph_USART1 | RCC_APB2Periph_GPIOA, ENABLE);
    /*------ USART1 --------*/
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_9;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
    GPIO_Init(GPIOA, &GPIO_InitStructure);
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_10;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
    GPIO_Init(GPIOA, &GPIO_InitStructure); //USART1IO
}

void RCC_Configuration(void)
{
    //RCCĴΪĬֵ
    RCC_DeInit();
    //ⲿʱӾ
    RCC_HSEConfig(RCC_HSE_ON); //RCC_HSEConfig(RCC_HSE_ON);//RCC_HSEConfig(RCC_HSE_OFF);
    //ȴⲿʱӾ
    RCC_WaitForHSEStartUp();
    //AHBʱ(HCLK)Ϊϵͳʱ
    RCC_HCLKConfig(RCC_SYSCLK_Div1);
    //øAHBʱ(APB2)ΪHCLKʱ
    RCC_PCLK2Config(RCC_HCLK_Div1);
    //õAHBʱ(APB1)ΪHCLK2Ƶ
    RCC_PCLK1Config(RCC_HCLK_Div2);

    //PLLʱӣΪHSE3Ƶ 25MHz * 3 = 75MHz
    RCC_PREDIV1Config(RCC_PREDIV1_Source_HSE,RCC_PREDIV1_Div1);
    //RCC_PLLConfig(RCC_PLLSource_PREDIV1, RCC_PLLMul_3_EXTEN);
    //ʹPLL
    //RCC_PLLCmd(ENABLE);
    //ȴPLL׼
    //while(RCC_GetFlagStatus(RCC_FLAG_PLLRDY) == RESET){};
    //PLLΪϵͳʱԴ
    RCC_SYSCLKConfig(RCC_SYSCLKSource_HSE);
    //жPLLǷϵͳʱ
    //while(RCC_GetSYSCLKSource() != 0x08){};/* Enable peripheral clocks*/
    /* GPIOA, GPIOB, GPIOC and GPIOD clock enable */
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA | RCC_APB2Periph_GPIOB |RCC_APB2Periph_GPIOC , ENABLE);
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOD  , ENABLE);
    /*USART1 clock enable*/
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_USART1, ENABLE);
    /* DMA1 clock enable */
    RCC_AHBPeriphClockCmd(RCC_AHBPeriph_DMA1, ENABLE);
    /* SRAM clock enable */
    RCC_AHBPeriphClockCmd(RCC_AHBPeriph_SRAM, ENABLE);
}

void USART_Configuration(void)
{
    USART_InitTypeDef USART_InitStructure;
    USART_ClockInitTypeDef  USART_ClockInitStructure;

    USART_InitStructure.USART_BaudRate = 115200;
    USART_ClockInitStructure.USART_Clock = USART_Clock_Disable;
    USART_ClockInitStructure.USART_CPOL = USART_CPOL_Low;
    USART_ClockInitStructure.USART_CPHA = USART_CPHA_2Edge;
    USART_ClockInitStructure.USART_LastBit = USART_LastBit_Disable;
    USART_ClockInit(USART1,&USART_ClockInitStructure);

    USART_InitStructure.USART_WordLength = USART_WordLength_8b;
    USART_InitStructure.USART_StopBits = USART_StopBits_1;
    USART_InitStructure.USART_Parity = USART_Parity_No ;
    USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
    USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;

    /* Configure the USARTx */
    USART_Init(USART1, &USART_InitStructure);

    USART_ITConfig(USART1,USART_IT_IDLE,ENABLE);
    /* Enable the USARTx */
    USART_Cmd(USART1, ENABLE);
    USART_DMACmd(USART1,USART_DMAReq_Tx|USART_DMAReq_Rx,ENABLE);
}

void NVIC_Config(void)
{
      NVIC_InitTypeDef NVIC_InitStructure;

      /* Deinitializes the NVIC */
      /* Set the Vector Table base address at 0x08000000 */
      #ifdef  VECT_TAB_RAM
      /* Set the Vector Table base location at 0x08000000 */
      NVIC_SetVectorTable(NVIC_VectTab_RAM, 0x0);
      #else  /* VECT_TAB_FLASH  */
      /* Set the Vector Table base location at 0x08000000 */
      //SCB->VTOR = FLASH_BASE | 0x10000 ;//FLASH_BASE | VECT_TAB_OFFSET;
      #endif


      NVIC_PriorityGroupConfig(NVIC_PriorityGroup_1); //Group1,ζPreemptionPrioritySubPriority8
      //PreemptionPriorityռʽȼһб͵ĳж϶ӦԼжϣ
      //SubPriorityڷʽȼ͵жУȴжִԼжϡ

      /* Enable the USART Interrupt */
      NVIC_InitStructure.NVIC_IRQChannel = USART1_IRQn;     //
      NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;
      NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
      NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
      NVIC_Init(&NVIC_InitStructure);
}



